# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.ActionFlow do
  @moduledoc """
  Flow that can be selected for an action. When merchant selects a flow, application should open a dialog with more information and input form.

  ## Attributes

  *   `dialogButtonLabel` (*type:* `String.t`, *default:* `nil`) - Label for the button to trigger the action from the action dialog. For example: "Request review"
  *   `dialogCallout` (*type:* `GoogleApi.Content.V21.Model.Callout.t`, *default:* `nil`) - Important message to be highlighted in the request dialog. For example: "You can only request a review for disagreeing with this issue once. If it's not approved, you'll need to fix the issue and wait a few days before you can request another review."
  *   `dialogMessage` (*type:* `GoogleApi.Content.V21.Model.TextWithTooltip.t`, *default:* `nil`) - Message displayed in the request dialog. For example: "Make sure you've fixed all your country-specific issues. If not, you may have to wait 7 days to request another review". There may be an more information to be shown in a tooltip.
  *   `dialogTitle` (*type:* `String.t`, *default:* `nil`) - Title of the request dialog. For example: "Before you request a review"
  *   `id` (*type:* `String.t`, *default:* `nil`) - Not for display but need to be sent back for the selected action flow.
  *   `inputs` (*type:* `list(GoogleApi.Content.V21.Model.InputField.t)`, *default:* `nil`) - A list of input fields.
  *   `label` (*type:* `String.t`, *default:* `nil`) - Text value describing the intent for the action flow. It can be used as an input label if merchant needs to pick one of multiple flows. For example: "I disagree with the issue"
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :dialogButtonLabel => String.t() | nil,
          :dialogCallout => GoogleApi.Content.V21.Model.Callout.t() | nil,
          :dialogMessage => GoogleApi.Content.V21.Model.TextWithTooltip.t() | nil,
          :dialogTitle => String.t() | nil,
          :id => String.t() | nil,
          :inputs => list(GoogleApi.Content.V21.Model.InputField.t()) | nil,
          :label => String.t() | nil
        }

  field(:dialogButtonLabel)
  field(:dialogCallout, as: GoogleApi.Content.V21.Model.Callout)
  field(:dialogMessage, as: GoogleApi.Content.V21.Model.TextWithTooltip)
  field(:dialogTitle)
  field(:id)
  field(:inputs, as: GoogleApi.Content.V21.Model.InputField, type: :list)
  field(:label)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.ActionFlow do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.ActionFlow.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.ActionFlow do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
