# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.ActionReason do
  @moduledoc """
  A single reason why the action is not available.

  ## Attributes

  *   `action` (*type:* `GoogleApi.Content.V21.Model.Action.t`, *default:* `nil`) - Optional. An action that needs to be performed to solve the problem represented by this reason. This action will always be available. Should be rendered as a link or button next to the summarizing message. For example, the review may be available only once merchant configure all required attributes. In such a situation this action can be a link to the form, where they can fill the missing attribute to unblock the main action.
  *   `detail` (*type:* `String.t`, *default:* `nil`) - Detailed explanation of the reason. Should be displayed as a hint if present.
  *   `message` (*type:* `String.t`, *default:* `nil`) - Messages summarizing the reason, why the action is not available. For example: "Review requested on Jan 03. Review requests can take a few days to complete."
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :action => GoogleApi.Content.V21.Model.Action.t() | nil,
          :detail => String.t() | nil,
          :message => String.t() | nil
        }

  field(:action, as: GoogleApi.Content.V21.Model.Action)
  field(:detail)
  field(:message)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.ActionReason do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.ActionReason.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.ActionReason do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
