# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.AttributionSettings do
  @moduledoc """
  Represents attribution settings for conversion sources receiving pre-attribution data.

  ## Attributes

  *   `attributionLookbackWindowInDays` (*type:* `integer()`, *default:* `nil`) - Required. Lookback windows (in days) used for attribution in this source. Supported values are 7, 30, 40.
  *   `attributionModel` (*type:* `String.t`, *default:* `nil`) - Required. Attribution model.
  *   `conversionType` (*type:* `list(GoogleApi.Content.V21.Model.AttributionSettingsConversionType.t)`, *default:* `nil`) - Immutable. Unordered list. List of different conversion types a conversion event can be classified as. A standard "purchase" type will be automatically created if this list is empty at creation time.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :attributionLookbackWindowInDays => integer() | nil,
          :attributionModel => String.t() | nil,
          :conversionType =>
            list(GoogleApi.Content.V21.Model.AttributionSettingsConversionType.t()) | nil
        }

  field(:attributionLookbackWindowInDays)
  field(:attributionModel)

  field(:conversionType,
    as: GoogleApi.Content.V21.Model.AttributionSettingsConversionType,
    type: :list
  )
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.AttributionSettings do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.AttributionSettings.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.AttributionSettings do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
