# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.AttributionSettingsConversionType do
  @moduledoc """
  Message representing a types of conversion events

  ## Attributes

  *   `includeInReporting` (*type:* `boolean()`, *default:* `nil`) - Output only. Option indicating if the type should be included in Merchant Center reporting.
  *   `name` (*type:* `String.t`, *default:* `nil`) - Output only. Conversion event name, as it'll be reported by the client.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :includeInReporting => boolean() | nil,
          :name => String.t() | nil
        }

  field(:includeInReporting)
  field(:name)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.AttributionSettingsConversionType do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.AttributionSettingsConversionType.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.AttributionSettingsConversionType do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
