# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.Callout do
  @moduledoc """
  An important message that should be highlighted. Usually displayed as a banner.

  ## Attributes

  *   `fullMessage` (*type:* `GoogleApi.Content.V21.Model.TextWithTooltip.t`, *default:* `nil`) - A full message that needs to be shown to the merchant.
  *   `styleHint` (*type:* `String.t`, *default:* `nil`) - Can be used to render messages with different severity in different styles. Snippets off all types contain important information that should be displayed to merchants.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :fullMessage => GoogleApi.Content.V21.Model.TextWithTooltip.t() | nil,
          :styleHint => String.t() | nil
        }

  field(:fullMessage, as: GoogleApi.Content.V21.Model.TextWithTooltip)
  field(:styleHint)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.Callout do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.Callout.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.Callout do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
