# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.DeliveryAreaPostalCodeRange do
  @moduledoc """
  A range of postal codes that defines the delivery area. Only set `firstPostalCode` when specifying a single postal code.

  ## Attributes

  *   `firstPostalCode` (*type:* `String.t`, *default:* `nil`) - Required. A postal code or a pattern of the form prefix* denoting the inclusive lower bound of the range defining the area. Examples values: `"94108"`, `"9410*"`, `"9*"`.
  *   `lastPostalCode` (*type:* `String.t`, *default:* `nil`) - A postal code or a pattern of the form prefix* denoting the inclusive upper bound of the range defining the area (for example [070* - 078*] results in the range [07000 - 07899]). It must have the same length as `firstPostalCode`: if `firstPostalCode` is a postal code then `lastPostalCode` must be a postal code too; if firstPostalCode is a pattern then `lastPostalCode` must be a pattern with the same prefix length. Ignored if not set, then the area is defined as being all the postal codes matching `firstPostalCode`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :firstPostalCode => String.t() | nil,
          :lastPostalCode => String.t() | nil
        }

  field(:firstPostalCode)
  field(:lastPostalCode)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.DeliveryAreaPostalCodeRange do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.DeliveryAreaPostalCodeRange.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.DeliveryAreaPostalCodeRange do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
