# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.InputFieldChoiceInput do
  @moduledoc """
  Choice input allows merchants to select one of the offered choices. Some choices may be linked to additional input fields that should be displayed under or next to the choice option. The value for the additional input field needs to be provided only when the specific choice is selected by the merchant. For example, additional input field can be hidden or disabled until the merchant selects the specific choice.

  ## Attributes

  *   `options` (*type:* `list(GoogleApi.Content.V21.Model.InputFieldChoiceInputChoiceInputOption.t)`, *default:* `nil`) - A list of choices. Only one option can be selected.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :options =>
            list(GoogleApi.Content.V21.Model.InputFieldChoiceInputChoiceInputOption.t()) | nil
        }

  field(:options,
    as: GoogleApi.Content.V21.Model.InputFieldChoiceInputChoiceInputOption,
    type: :list
  )
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.InputFieldChoiceInput do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.InputFieldChoiceInput.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.InputFieldChoiceInput do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
