# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.InputFieldChoiceInputChoiceInputOption do
  @moduledoc """
  A choice that merchant can select.

  ## Attributes

  *   `additionalInput` (*type:* `GoogleApi.Content.V21.Model.InputField.t`, *default:* `nil`) - Input that should be displayed when this option is selected. The additional input will not contain a `ChoiceInput`.
  *   `id` (*type:* `String.t`, *default:* `nil`) - Not for display but need to be sent back for the selected choice option.
  *   `label` (*type:* `GoogleApi.Content.V21.Model.TextWithTooltip.t`, *default:* `nil`) - Short description of the choice option. There may be more information to be shown as a tooltip.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :additionalInput => GoogleApi.Content.V21.Model.InputField.t() | nil,
          :id => String.t() | nil,
          :label => GoogleApi.Content.V21.Model.TextWithTooltip.t() | nil
        }

  field(:additionalInput, as: GoogleApi.Content.V21.Model.InputField)
  field(:id)
  field(:label, as: GoogleApi.Content.V21.Model.TextWithTooltip)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.InputFieldChoiceInputChoiceInputOption do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.InputFieldChoiceInputChoiceInputOption.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.InputFieldChoiceInputChoiceInputOption do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
