# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.InputFieldTextInput do
  @moduledoc """
  Text input allows merchants to provide a text value.

  ## Attributes

  *   `additionalInfo` (*type:* `GoogleApi.Content.V21.Model.TextWithTooltip.t`, *default:* `nil`) - Additional info regarding the field to be displayed to merchant. For example, warning to not include personal identifiable information. There may be more information to be shown in a tooltip.
  *   `ariaLabel` (*type:* `String.t`, *default:* `nil`) - Text to be used as the [aria label](https://www.w3.org/TR/WCAG20-TECHS/ARIA14.html) for the input.
  *   `formatInfo` (*type:* `String.t`, *default:* `nil`) - Information about the required format. If present, it should be shown close to the input field to help merchants to provide a correct value. For example: "VAT numbers should be in a format similar to SK9999999999"
  *   `type` (*type:* `String.t`, *default:* `nil`) - Type of the text input
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :additionalInfo => GoogleApi.Content.V21.Model.TextWithTooltip.t() | nil,
          :ariaLabel => String.t() | nil,
          :formatInfo => String.t() | nil,
          :type => String.t() | nil
        }

  field(:additionalInfo, as: GoogleApi.Content.V21.Model.TextWithTooltip)
  field(:ariaLabel)
  field(:formatInfo)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.InputFieldTextInput do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.InputFieldTextInput.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.InputFieldTextInput do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
