# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.InputValue do
  @moduledoc """
  Input provided by the merchant for input field.

  ## Attributes

  *   `checkboxInputValue` (*type:* `GoogleApi.Content.V21.Model.InputValueCheckboxInputValue.t`, *default:* `nil`) - Value for checkbox input field.
  *   `choiceInputValue` (*type:* `GoogleApi.Content.V21.Model.InputValueChoiceInputValue.t`, *default:* `nil`) - Value for choice input field.
  *   `inputFieldId` (*type:* `String.t`, *default:* `nil`) - Required. Id of the corresponding input field.
  *   `textInputValue` (*type:* `GoogleApi.Content.V21.Model.InputValueTextInputValue.t`, *default:* `nil`) - Value for text input field.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :checkboxInputValue =>
            GoogleApi.Content.V21.Model.InputValueCheckboxInputValue.t() | nil,
          :choiceInputValue => GoogleApi.Content.V21.Model.InputValueChoiceInputValue.t() | nil,
          :inputFieldId => String.t() | nil,
          :textInputValue => GoogleApi.Content.V21.Model.InputValueTextInputValue.t() | nil
        }

  field(:checkboxInputValue, as: GoogleApi.Content.V21.Model.InputValueCheckboxInputValue)
  field(:choiceInputValue, as: GoogleApi.Content.V21.Model.InputValueChoiceInputValue)
  field(:inputFieldId)
  field(:textInputValue, as: GoogleApi.Content.V21.Model.InputValueTextInputValue)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.InputValue do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.InputValue.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.InputValue do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
