# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.InsertCheckoutSettingsRequest do
  @moduledoc """
  Request message for the `InsertCheckoutSettings` method.

  ## Attributes

  *   `uriSettings` (*type:* `GoogleApi.Content.V21.Model.UrlSettings.t`, *default:* `nil`) - Required. The `UrlSettings` for the request. The presence of URL settings indicates `Checkout` enrollment.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :uriSettings => GoogleApi.Content.V21.Model.UrlSettings.t() | nil
        }

  field(:uriSettings, as: GoogleApi.Content.V21.Model.UrlSettings)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.InsertCheckoutSettingsRequest do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.InsertCheckoutSettingsRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.InsertCheckoutSettingsRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
