# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.ProductStructuredDescription do
  @moduledoc """
  Structured description, for algorithmically (AI)-generated descriptions. See [description](https://support.google.com/merchants/answer/6324468#When_to_use) for more information.

  ## Attributes

  *   `content` (*type:* `String.t`, *default:* `nil`) - Required. The description text. Maximum length is 5000 characters.
  *   `digitalSourceType` (*type:* `String.t`, *default:* `nil`) - Optional. The digital source type. Acceptable values are: - "`trained_algorithmic_media`" - "`default`" 
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :content => String.t() | nil,
          :digitalSourceType => String.t() | nil
        }

  field(:content)
  field(:digitalSourceType)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.ProductStructuredDescription do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.ProductStructuredDescription.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.ProductStructuredDescription do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
