# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.PromotionPromotionStatus do
  @moduledoc """
  The status of the promotion.

  ## Attributes

  *   `creationDate` (*type:* `String.t`, *default:* `nil`) - Date on which the promotion has been created in [ISO 8601](http://en.wikipedia.org/wiki/ISO_8601) format: Date, time, and offset, for example "2020-01-02T09:00:00+01:00" or "2020-01-02T09:00:00Z"
  *   `destinationStatuses` (*type:* `list(GoogleApi.Content.V21.Model.PromotionPromotionStatusDestinationStatus.t)`, *default:* `nil`) - The intended destinations for the promotion.
  *   `lastUpdateDate` (*type:* `String.t`, *default:* `nil`) - Date on which the promotion status has been last updated in [ISO 8601](http://en.wikipedia.org/wiki/ISO_8601) format: Date, time, and offset, for example "2020-01-02T09:00:00+01:00" or "2020-01-02T09:00:00Z"
  *   `promotionIssue` (*type:* `list(GoogleApi.Content.V21.Model.PromotionPromotionStatusPromotionIssue.t)`, *default:* `nil`) - A list of issues associated with the promotion.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :creationDate => String.t() | nil,
          :destinationStatuses =>
            list(GoogleApi.Content.V21.Model.PromotionPromotionStatusDestinationStatus.t()) | nil,
          :lastUpdateDate => String.t() | nil,
          :promotionIssue =>
            list(GoogleApi.Content.V21.Model.PromotionPromotionStatusPromotionIssue.t()) | nil
        }

  field(:creationDate)

  field(:destinationStatuses,
    as: GoogleApi.Content.V21.Model.PromotionPromotionStatusDestinationStatus,
    type: :list
  )

  field(:lastUpdateDate)

  field(:promotionIssue,
    as: GoogleApi.Content.V21.Model.PromotionPromotionStatusPromotionIssue,
    type: :list
  )
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.PromotionPromotionStatus do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.PromotionPromotionStatus.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.PromotionPromotionStatus do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
