# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.RecommendationDescription do
  @moduledoc """
  Google-provided description for the recommendation.

  ## Attributes

  *   `text` (*type:* `String.t`, *default:* `nil`) - Output only. Text of the description.
  *   `type` (*type:* `String.t`, *default:* `nil`) - Output only. Type of the description.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :text => String.t() | nil,
          :type => String.t() | nil
        }

  field(:text)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.RecommendationDescription do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.RecommendationDescription.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.RecommendationDescription do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
