# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.ReportInteractionRequest do
  @moduledoc """
  Request to report interactions on a recommendation.

  ## Attributes

  *   `interactionType` (*type:* `String.t`, *default:* `nil`) - Required. Type of the interaction that is reported, for example INTERACTION_CLICK.
  *   `responseToken` (*type:* `String.t`, *default:* `nil`) - Required. Token of the response when recommendation was returned.
  *   `subtype` (*type:* `String.t`, *default:* `nil`) - Optional. Subtype of the recommendations this interaction happened on. This field must be set only to the value that is returned by {@link `RecommendationsService.GenerateRecommendations`} call.
  *   `type` (*type:* `String.t`, *default:* `nil`) - Required. Type of the recommendations on which this interaction happened. This field must be set only to the value that is returned by {@link `GenerateRecommendationsResponse`} call.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :interactionType => String.t() | nil,
          :responseToken => String.t() | nil,
          :subtype => String.t() | nil,
          :type => String.t() | nil
        }

  field(:interactionType)
  field(:responseToken)
  field(:subtype)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.ReportInteractionRequest do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.ReportInteractionRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.ReportInteractionRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
