# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.UrlSettings do
  @moduledoc """
  Specifications related to the `Checkout` URL. The `UriTemplate` is of the form `https://www.mystore.com/checkout?item_id={id}` where `{id}` will be automatically replaced with data from the merchant account with this attribute [offer_id](https://developers.google.com/shopping-content/reference/rest/v2.1/products#Product.FIELDS.offer_id)

  ## Attributes

  *   `cartUriTemplate` (*type:* `String.t`, *default:* `nil`) - URL template when the placeholders are expanded will redirect the buyer to the cart page on the merchant website with the selected item in cart.
  *   `checkoutUriTemplate` (*type:* `String.t`, *default:* `nil`) - URL template when the placeholders are expanded will redirect the buyer to the merchant checkout page with the item in the cart.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :cartUriTemplate => String.t() | nil,
          :checkoutUriTemplate => String.t() | nil
        }

  field(:cartUriTemplate)
  field(:checkoutUriTemplate)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.UrlSettings do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.UrlSettings.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.UrlSettings do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
